//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * TEhXgwb_
 * @author Junpee
 */

#ifndef SOUND_LIST_H_
#define SOUND_LIST_H_

namespace Lamp{

class SoundCache;
class TextReader;

//------------------------------------------------------------------------------
/**
 * TEhXg
 *
 * eLXgt@CTEhXgTEhLbVɓǂݍށB
 * ̓Iɂ̓TEht@CuĂfBNgɈȉɎtH[}bg
 * eLXgt@CzuB̌ATEhLbVloadSoundList()
 * gpăTEhXg[h܂B
 * ̃t@C̓GNZ̃c[ŕҏWƊył傤B<br>
 * <br>
 * <hr>
 * // śu//vRgɑΉĂB evf̓^uŋ؂B<br>
 * //t@C	Stereo,3D	Once,Loop	Priority	MaxMixingCount	Min3DDistance
 * Max3DDistance<br>
 * muda	Stereo	Once	-1	0<br>
 * mudamuda	3D	Loop	100	16	5.73	76.5<br>
 * <hr>
 * t@C<br>
 * @΃t@Cw肵܂Bgq̓TEhLbVŎw肷
 * ł傤B<br>
 * <br>
 * Stereo,3D<br>
 * @XeITEh3DTEhw肵܂B3DTEh̓młKv
 * ܂B<br>
 * <br>
 * Once,Loop<br>
 * @̍Đ[vĐw肵܂B<br>
 * <br>
 * Priority<br>
 * @Dx32767`-32768͈̔͂Ŏw肵܂BǂĂĂق̗Dx
 * グ܂傤B<br>
 * <br>
 * MaxMixingCount<br>
 * @ő哯w肵܂B0w肷ƃTEhLbṼftHgl
 * gp܂<br>
 * <br>
 * Min3DDistance<br>
 *  3DTEh̍ŏw肵܂B<br>
 * <br>
 * Max3DDistance<br>
 *  3DTEh̍ő勗w肵܂B<br>
 */
class SoundList{
public:
	/**
	 * [h
	 * @param soundCache TEhLbV
	 * @param filePath t@CpX
	 * @return true
	 */
	static bool load(SoundCache* soundCache, const String& filePath);

	/**
	 * [h
	 * @param soundCache TEhLbV
	 * @param textReader eLXg[_
	 * @return true
	 */
	static bool load(SoundCache* soundCache, TextReader* textReader);

	/**
	 * TEh̃[h
	 * @param soundCache TEhLbV
	 * @param line [h
	 * @return true
	 */
	static bool loadSound(SoundCache* soundCache, const String& line);


private:
	// RXgN^̉B
	SoundList();

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of SOUND_LIST_H_
//------------------------------------------------------------------------------

