//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 4~4seXgwb_
 * @author Junpee
 */

#ifndef MATRIX44_TEST_H_
#define MATRIX44_TEST_H_

#include <LampUnit/TestCase.h>

namespace Lamp{ class Matrix44; }

//------------------------------------------------------------------------------
/**
 * 4~4seXg
 */
class Matrix44Test : public TestCase{
public:
	/**
	 * RXgN^
	 * @param name eXg̖O
	 */
	explicit Matrix44Test(String name);

	/**
	 * eXgs
	 */
	virtual void runTest(){}

	/**
	 * eXgXB[g̎擾
	 * @return eXgXB[g
	 */
	static Test* suite();

	// RXgN^eXg
	virtual void testConstructor();

	// 萔eXg
	virtual void testFixedNumber();

	// l̐ݒeXg
	virtual void testSetValue();

	// XP[eXg
	virtual void testScale();

	// ]eXg
	virtual void testRotation();

	// leXg
	virtual void testQuaternion();

	// O]eXg
	virtual void testThreeAxisRotation();

	// ړeXg
	virtual void testTranslation();

	// ϊeXg
	virtual void testTransformation();

	// ZeXg
	virtual void testMul();

	// s񉉎ZeXg
	virtual void testMatrixOperation();

	// _ZeXg
	virtual void testLogicalOperation();

	// eXg
	virtual void testToString();

private:
	// Direct3DsƂ̔r
	bool d3dEquals(D3DXMATRIX& d3d, Matrix44& mtx);

	// Direct3DsƂ̔r
	bool d3dEpsilonEquals(D3DXMATRIX& d3d, Matrix44& mtx, float epsilon);

};

//------------------------------------------------------------------------------
#endif // End of MATRIX44_TEST_H_
//------------------------------------------------------------------------------
